var matr1 = null;
var matr2 = null;
var k1 = 0;
var k2 = 0;
var actMs = [];
var baseMs = [];
var actMs2 = [];
var baseMs2 = [];
var actControl = [];
var actControl2 = [];
var baseControl = [];
var baseControl2 = [];
var maxComp = 30;
var lastk1 = 0;
var lastk2 = 0;
var change1 = 0;
var change2 = 0;
var oriFrames1;
var oriFrames2;
var currBaseName; 

function delete1(){

	currMatr = patcher.getnamed('matr1');
	patcher.remove(currMatr);
	
	currMatr = patcher.getnamed('xMatr1');
	patcher.remove(currMatr);
	
	currMatr = patcher.getnamed('xMatr2');
	patcher.remove(currMatr);

	for (i=0; i<maxComp; i++){
		currAct = patcher.getnamed('actMs'+i);
		patcher.remove(currAct);
		
		currControl = patcher.getnamed('actControl'+i);
		patcher.remove(currControl);
	}
	
	for (i=0; i<maxComp; i++){
		currAct = patcher.getnamed('baseMs'+i);
		patcher.remove(currAct);
		
		currControl = patcher.getnamed('baseControl'+i);
		patcher.remove(currControl);
	}
	
	decoder = patcher.getnamed("decodeJS");
	decoder.message("setDoneFact1",0);
	
}

function delete2(){

	currMatr = patcher.getnamed('matr2');
	patcher.remove(currMatr);
	
	currMatr = patcher.getnamed('xMatr1');
	patcher.remove(currMatr);
	
	currMatr = patcher.getnamed('xMatr2');
	patcher.remove(currMatr);
	
	for (i=0; i<maxComp; i++){
		currAct = patcher.getnamed('actMs2_'+i);
		patcher.remove(currAct);
		
		currControl = patcher.getnamed('actControl2_'+i);
		patcher.remove(currControl);
	}
	
	for (i=0; i<maxComp; i++){
		currAct = patcher.getnamed('baseMs2_'+i);
		patcher.remove(currAct);
		
		currControl = patcher.getnamed('baseControl2_'+i);
		patcher.remove(currControl);
	}
	
	decoder = patcher.getnamed("decodeJS");
	decoder.message("setDoneFact2",0);
}

function deleteAll(){

	this.delete1();
	this.delete2();
	
}

function setBaseRange1(min,baseNo){
    
    currName = 'baseMs'+(baseNo-1);
    currObj = patcher.getnamed(currName);
    currObj.message('setminmax',[min,0.]);
    
}

function setBaseRange2(min,baseNo){
    
    currName = 'baseMs2_'+(baseNo-1);
    currObj = patcher.getnamed(currName);
    currObj.message('setminmax',[min,0.]);

}


function adaptFrames(){
	
	var maxFrames = oriFrames1;
	if (oriFrames1>oriFrames2){
		if (lastk1 === 0){
			maxFrames = oriFrames2;
		} else {
			maxFrames = oriFrames1;
		}
	} else if (oriFrames2>oriFrames1) {
		if (lastk2 === 0){
			maxFrames = oriFrames1;
		} else {
			maxFrames = oriFrames2;
		}
	} 
	
	for (i=0; i<lastk2; i++){
		currName = 'actMs2_'+i;
		currObj = patcher.getnamed(currName);
		if (currObj==null)
			return;
		currObj.message("size",maxFrames);
	}
	for (i=0; i<lastk1; i++){
		currName = 'actMs'+i;
		currObj = patcher.getnamed(currName);
		if (currObj==null)
			return;
		currObj.message("size",maxFrames);
	}
		
		
}

function setFrames1(zero){
	
	if (zero==1){
		oriFrames1 = 0;
	} else {	
		if (lastk1>0){
		currName = 'actMs0';
		currObj = patcher.getnamed(currName);
		oriFrames1 = currObj.getattr("size");
		}
	}
	
	this.adaptFrames();
	
}

function setFrames2(zero){
	
	if (zero==1){
		oriFrames2 = 0;
	} else {
		if (lastk2>0){
			currName = 'actMs2_0';
			currObj = patcher.getnamed(currName);
			oriFrames2 = currObj.getattr("size");
		}
	}
	
	this.adaptFrames();
	
}

function thisMin(currMin){
	
	currObj = patcher.getnamed(currBaseName);
	currObj.message('setminmax',[currMin,0.]);
	
}

function normBases(){
	
	collector = patcher.getnamed('collBase');
	subpatch = collector.subpatcher();
	minObj = subpatch.getnamed('minReg');
	
	for (i=0; i<lastk1; i++){
		
		currBaseName = 'baseMs'+i;
		currObj = patcher.getnamed(currBaseName);
		currObj.message('bang');
		
		minObj.message('bang');
		
	}
	
	for (i=0; i<lastk2; i++){
		
		currBaseName = 'baseMs2_'+i;
		currObj = patcher.getnamed(currBaseName);
		currObj.message('bang');
		
		minObj.message('bang');
		
	}
	
}

function display(k1,k2)
{
	change1 = 0;
	change2 = 0;
		
	if (k1 !== lastk1){
		this.delete1();
		change1 = 1;
		lastk1 = k1;
	} else if (k2 !== lastk2){
		this.delete2();
		change2 = 1;
		lastk2 = k2;
	} else {
		return;
	}
	
	matrixControl = patcher.getnamed("matrixControl");
	
	fillActGt1 = patcher.getnamed("fillActGt1");   // fill gate 1
	fillActGt2 = patcher.getnamed("fillActGt2");
	fillBaseGt1 = patcher.getnamed("fillBaseGt1");
	fillBaseGt2 = patcher.getnamed("fillBaseGt2");
	
	collAct1 = patcher.getnamed("collAct1");
	collAct2 = patcher.getnamed("collAct2");
	collBase = patcher.getnamed("collBase");
	
	
	var matr1_pres_pos_x = 450;
	var matr1_pres_pos_y = 410;
	
	var pres_patch_offset_x = 1100;
	var pres_patch_offset_y = 120;
		
	var actMs_length = 390;
	var actMs_height = 55;
	var baseMs_length = actMs_height;
	var baseMs_height = 342;
	var space = 10; 	
	
	var actControl_length = 42;
	var actControl_height = 70;
	
	var actMs_pres_x = matr1_pres_pos_x - space - actMs_length;
	var actMs_patch_x = actMs_pres_x + pres_patch_offset_x;
	
	var matr1_size = actMs_height*k1 + space*(k1-1); // width = length

	var baseMs_pres_y = matr1_pres_pos_y - space - baseMs_height;
	var baseMs_patch_y = baseMs_pres_y + pres_patch_offset_y;

	
	if (k1>0)
	{
		var matr1_patch_pos_x = matr1_pres_pos_x + pres_patch_offset_x;
		var matr1_patch_pos_y = matr1_pres_pos_y + pres_patch_offset_y;
		
		// create upper left matrix
		if (change1>0){
			
			matr1 = patcher.newdefault(matr1_patch_pos_x,matr1_patch_pos_y,"matrixctrl","@rows",k1,"@columns",k1,
				"@patching_rect",matr1_patch_pos_x,matr1_patch_pos_y,matr1_size,matr1_size,
				"@presentation",1,"@presentation_rect",matr1_pres_pos_x,matr1_pres_pos_y,matr1_size,matr1_size,
				"@color",0.541176,0.815686,0.913725,1.0);	
			
			matr1.varname = "matr1";	
			matr1.ignoreclick = 1;

			patcher.connect(matr1,0,matrixControl,2);
			patcher.connect(matrixControl,1,matr1,0);
		
		
			// activation multisliders
					
			for (i=0; i<k1; i++){
		
				var actMs_pres_y = matr1_pres_pos_y + ((actMs_height+space)*i);
				var actMs_patch_y = actMs_pres_y + pres_patch_offset_y;
		
				actMs[i] = patcher.newdefault(actMs_patch_x,actMs_patch_y,"multislider",
					"@patching_rect",actMs_patch_x,actMs_patch_y,actMs_length,actMs_height,
					"@presentation",1,"@presentation_rect",actMs_pres_x,actMs_pres_y,actMs_length,actMs_height,
					"@setstyle",1,"@setminmax",0,1);
			
				actMs[i].varname = 'actMs'+i;
				
				patcher.connect(fillActGt1,i,actMs[i],0);
				patcher.connect(actMs[i],0,collAct1,1);
				
				actControl[i] = patcher.newdefault(actMs_patch_x-actControl_length,actMs_patch_y,"bpatcher","@name","activationControl",
					"@patching_rect",actMs_patch_x-actControl_length,actMs_patch_y,actControl_length,actControl_height,
					"@presentation",1,"@presentation_rect",actMs_pres_x-actControl_length,actMs_pres_y,actMs_length,actMs_height);
					
				actControl[i].varname = 'actControl'+i;
			
				patcher.connect(fillActGt1,i,actControl[i],0);
				patcher.connect(actMs[i],0,actControl[i],1);
				patcher.connect(actControl[i],0,actMs[i],0);
				
				actControl[i].subpatcher().getnamed("label").message("set","A"+(i+1));
			
			}
		
			// base multisliders
			for (i=0; i<k1; i++){
		
				var baseMs_pres_x = matr1_pres_pos_x + ((baseMs_length+space)*i);
				var baseMs_patch_x = baseMs_pres_x + pres_patch_offset_x;
		
				baseMs[i] = patcher.newdefault(baseMs_patch_x,baseMs_patch_y,"multislider",
					"@patching_rect",baseMs_patch_x,baseMs_patch_y,baseMs_length,baseMs_height,
					"@presentation",1,"@presentation_rect",baseMs_pres_x,baseMs_pres_y,baseMs_length,baseMs_height,
					"@setstyle",1,"@setminmax",-8.,0.,"@orientation",0,
					"@bgcolor",0.880169,0.755396,0.471904,1.0,
					"@slidercolor",0.290196,0.309804,0.301961,1.0);
				
				baseMs[i].varname = 'baseMs'+i;
			
				patcher.connect(fillBaseGt1,i,baseMs[i],0);
				patcher.connect(baseMs[i],0,collBase,0);
				patcher.connect(baseMs[i],0,collBase,1);
				
				
				baseControl[i] = patcher.newdefault(baseMs_patch_x,baseMs_patch_y-actControl_length,"bpatcher","@name","baseControl",
					"@patching_rect",baseMs_patch_x,baseMs_patch_y-actControl_length,actControl_height,actControl_length,
					"@presentation",1,"@presentation_rect",baseMs_pres_x,baseMs_pres_y-actControl_length,actControl_height,actControl_length);
					
				baseControl[i].varname = 'baseControl'+i;
			
				patcher.connect(fillBaseGt1,i,baseControl[i],0);
				patcher.connect(baseMs[i],0,baseControl[i],1);
				patcher.connect(baseControl[i],0,baseMs[i],0);
				
				baseControl[i].subpatcher().getnamed("label").message("set","A"+(i+1));
				
			}
		} // if change1
		
		
	}
	
	// create lower right matrix
	if (k2>0)
	{
		
		var matr2_size = actMs_height*k2 + space*(k2-1); // width = length
		var matr2_pres_pos_x = matr1_pres_pos_x + space + matr1_size;
		var matr2_pres_pos_y = matr1_pres_pos_y + space + matr1_size;
		var matr2_patch_pos_x = matr2_pres_pos_x + pres_patch_offset_x;
		var matr2_patch_pos_y = matr2_pres_pos_y + pres_patch_offset_y;
		
		if (change2>0){
	
			matr2 = patcher.newdefault(matr2_patch_pos_x,matr2_patch_pos_y,"matrixctrl","@rows",k2,"@columns",k2,
				"@patching_rect",matr2_patch_pos_x,matr2_patch_pos_y,matr2_size,matr2_size,
				"@presentation",1,"@presentation_rect",matr2_pres_pos_x,matr2_pres_pos_y,matr2_size,matr2_size,
				"@color",0.541176,0.815686,0.913725,1.0);
			
			matr2.varname = "matr2";
			matr2.ignoreclick = 1;

			patcher.connect(matr2,0,matrixControl,5);
			patcher.connect(matrixControl,4,matr2,0);	
		
			// activation multisliders
			for (i=0; i<k2; i++){
		
				var actMs_pres_y = matr1_pres_pos_y + ((actMs_height+space)*(i+k1));
				var actMs_patch_y = actMs_pres_y + pres_patch_offset_y;
		
				actMs2[i] = patcher.newdefault(actMs_patch_x,actMs_patch_y,"multislider",
					"@patching_rect",actMs_patch_x,actMs_patch_y,actMs_length,actMs_height,
					"@presentation",1,"@presentation_rect",actMs_pres_x,actMs_pres_y,actMs_length,actMs_height,
					"@setstyle",1,"@setminmax",0,1);
				
				actMs2[i].varname = 'actMs2_'+i;
				
				patcher.connect(fillActGt2,i,actMs2[i],0);
				patcher.connect(actMs2[i],0,collAct2,1);
				
				actControl2[i] = patcher.newdefault(actMs_patch_x,actMs_patch_y,"bpatcher","@name","activationControl",
					"@patching_rect",actMs_patch_x-actControl_length,actMs_patch_y,actControl_length,actControl_height,
					"@presentation",1,"@presentation_rect",actMs_pres_x-actControl_length,actMs_pres_y,actMs_length,actMs_height);
			
				actControl2[i].varname = 'actControl2_'+i;
	
				patcher.connect(fillActGt2,i,actControl2[i],0);
				patcher.connect(actMs2[i],0,actControl2[i],1);
				patcher.connect(actControl2[i],0,actMs2[i],0);
				
				actControl2[i].subpatcher().getnamed("label").message("set","B"+(i+1));
			}
		
			// base multisliders
			for (i=0; i<k2; i++){
				
				var baseMs_pres_x = matr1_pres_pos_x + ((baseMs_length+space)*(i+k1));
				var baseMs_patch_x = baseMs_pres_x + pres_patch_offset_x;
		
				baseMs2[i] = patcher.newdefault(baseMs_patch_x,baseMs_patch_y,"multislider",
					"@patching_rect",baseMs_patch_x,baseMs_patch_y,baseMs_length,baseMs_height,
					"@presentation",1,"@presentation_rect",baseMs_pres_x,baseMs_pres_y,baseMs_length,baseMs_height,
					"@setstyle",1,"@setminmax",-8.,0.,"@orientation",0,
					"@bgcolor",0.880169,0.755396,0.471904,1.0,
					"@slidercolor",0.290196,0.309804,0.301961,1.0);
				
				baseMs2[i].varname = 'baseMs2_'+i;
			
				patcher.connect(fillBaseGt2,i,baseMs2[i],0);
				patcher.connect(baseMs2[i],0,collBase,0);
				patcher.connect(baseMs2[i],0,collBase,1);
				
				baseControl2[i] = patcher.newdefault(baseMs_patch_x,baseMs_patch_y-actControl_length,"bpatcher","@name","baseControl",
					"@patching_rect",baseMs_patch_x,baseMs_patch_y-actControl_length,actControl_height,actControl_length,
					"@presentation",1,"@presentation_rect",baseMs_pres_x,baseMs_pres_y-actControl_length,actControl_height,actControl_length);
					
				baseControl2[i].varname = 'baseControl2_'+i;
			
				patcher.connect(fillBaseGt2,i,baseControl2[i],0);
				patcher.connect(baseMs2[i],0,baseControl2[i],1);
				patcher.connect(baseControl2[i],0,baseMs2[i],0);
				
				baseControl2[i].subpatcher().getnamed("label").message("set","B"+(i+1));
				
			}
		} else if (change1>0) { // just move
			
			matr2 = patcher.getnamed("matr2");
			if (matr2==null){
				return;
			}
			matr2.message("patching_rect",[matr2_patch_pos_x,matr2_patch_pos_y,matr2_size,matr2_size]);
			matr2.message("presentation_rect",[matr2_pres_pos_x,matr2_pres_pos_y,matr2_size,matr2_size]);
	
			for (i=0; i<k2; i++){
				
				var actMs_pres_y = matr1_pres_pos_y+((actMs_height+space)*(i+k1));
				var actMs_patch_y = actMs_pres_y + pres_patch_offset_y;
				
				currMs = patcher.getnamed('actMs2_'+i);
				currMs.message("patching_rect",[actMs_patch_x,actMs_patch_y,actMs_length,actMs_height]);
				currMs.message("presentation_rect",[actMs_pres_x,actMs_pres_y,actMs_length,actMs_height]);

				this.patcher.message("script", "sendbox", 'actControl2_'+i, "patching_rect", actMs_patch_x-actControl_length,actMs_patch_y,actControl_length,actControl_height);
				this.patcher.message("script", "sendbox", 'actControl2_'+i, "presentation_rect", actMs_pres_x-actControl_length,actMs_pres_y,actControl_length,actControl_height);

				var baseMs_pres_x = matr1_pres_pos_x + ((baseMs_length+space)*(i+k1));
				var baseMs_patch_x = baseMs_pres_x + pres_patch_offset_x;
								
				currMs = patcher.getnamed('baseMs2_'+i);
				currMs.message("patching_rect",[baseMs_patch_x,baseMs_patch_y,baseMs_length,baseMs_height]);
				currMs.message("presentation_rect",[baseMs_pres_x,baseMs_pres_y,baseMs_length,baseMs_height]);
				
				this.patcher.message("script", "sendbox", 'baseControl2_'+i, "patching_rect", baseMs_patch_x,baseMs_patch_y-actControl_length,actControl_height,actControl_length);
				this.patcher.message("script", "sendbox", 'baseControl2_'+i, "presentation_rect", baseMs_pres_x,baseMs_pres_y-actControl_length,actControl_height,actControl_length);
				
			}
			
		}
		
		if (k1>0){
		// lower-left x-matrix
		var xMatr1_patch_pos_x = matr1_patch_pos_x;
		var xMatr1_patch_pos_y = matr2_patch_pos_y;
		var xMatr1_pres_pos_x = matr1_pres_pos_x;
		var xMatr1_pres_pos_y = matr2_pres_pos_y;
		var xMatr1_width = matr1_size;
		var xMatr1_height = matr2_size;
		
		xMatr1 = patcher.newdefault(xMatr1_patch_pos_x,xMatr1_patch_pos_y,"matrixctrl","@rows",k2,"@columns",k1,
			"@patching_rect",xMatr1_patch_pos_x,xMatr1_patch_pos_y,xMatr1_width,xMatr1_height,
			"@presentation",1,"@presentation_rect",xMatr1_pres_pos_x,xMatr1_pres_pos_y,xMatr1_width,xMatr1_height,
			"@color",0.63,0.28,0.18,1.0,"@bgcolor",0.2,0.19,0.2,1.0);
		
		xMatr1.varname = "xMatr1";
		xMatr1.ignoreclick = 1;
		patcher.connect(xMatr1,0,matrixControl,4);
		patcher.connect(matrixControl,3,xMatr1,0);
		
		
		// upper-right x-matrix
		var xMatr2_patch_pos_x = matr2_patch_pos_x;
		var xMatr2_patch_pos_y = matr1_patch_pos_y;
		var xMatr2_pres_pos_x = matr2_pres_pos_x;
		var xMatr2_pres_pos_y = matr1_pres_pos_y;
		var xMatr2_width = matr2_size;
		var xMatr2_height = matr1_size;
		
		xMatr2 = patcher.newdefault(xMatr2_patch_pos_x,xMatr2_patch_pos_y,"matrixctrl","@rows",k1,"@columns",k2,
			"@patching_rect",xMatr2_patch_pos_x,xMatr2_patch_pos_y,xMatr2_width,xMatr2_height,
			"@presentation",1,"@presentation_rect",xMatr2_pres_pos_x,xMatr2_pres_pos_y,xMatr2_width,xMatr2_height,
			"@color",0.63,0.28,0.18,1.0,"@bgcolor",0.2,0.19,0.2,1.0);
		
		xMatr2.varname = "xMatr2";
		xMatr2.ignoreclick = 1;
		patcher.connect(xMatr2,0,matrixControl,3);
		patcher.connect(matrixControl,2,xMatr2,0);
		} // if k1>0
		
	} // if k2>0
} // function display