function clearNoOut(currMatr,rows,cols){

	for(i=0; i<rows; i++){
		for(j=0; j<cols; j++){
			currMatr.message("set",j,i,0);
		}
	}
	
}

function reconstr(matr){

	currMatr = patcher.getnamed(matr);
	
	if (currMatr==null){
		return;
	}
	
	var rows = currMatr.getattr("rows");
	var cols = currMatr.getattr("columns");
	clearNoOut(currMatr,rows,cols);
	
	if ((matr=='xMatr1') || (matr=='xMatr2'))
		return;
	
	for(i=0; i<rows; i++){
		currMatr.message("set",i,i,1);
	}
	
}

function clear(matr){
	
	currMatr = patcher.getnamed(matr);
	
	if (currMatr==null){
		return;
	}
	
	var rows = currMatr.getattr("rows");
	var cols = currMatr.getattr("columns");
	clearNoOut(currMatr,rows,cols);
	
}

function clearDiag(matr){
	
	if ((matr=='xMatr1') || (matr=='xMatr2'))
		return;
	
	currMatr = patcher.getnamed(matr);
	
	if (currMatr==null){
		return;
	}
	
	var rows = currMatr.getattr("rows");
	
	for(i=0; i<rows; i++){
		currMatr.message("set",i,i,0);
	}
	
}

function random(matr){
	
	currMatr = patcher.getnamed(matr);
	if (currMatr==null){
		return;
	}
	var rows = currMatr.getattr("rows");
	var cols = currMatr.getattr("columns");
	clearNoOut(currMatr,rows,cols);
	
	for(i=0; i<rows; i++){
		for(j=0; j<cols; j++){
			currMatr.message("set",j,i,Math.floor(Math.random()*2));
		}
	}
	
}

function scramble(matr){
	
	currMatr = patcher.getnamed(matr);
	if (currMatr==null){
		return;
	}
	var rows = currMatr.getattr("rows");
	var cols = currMatr.getattr("columns");
	
	clearNoOut(currMatr,rows,cols);
	
	var indCols = [];
	for (i=0; i<cols; i++){
		indCols[i] = i;
	}
	indCols = this.randPerm(indCols);
	
	var indRows = [];
	for (i=0; i<rows; i++){
		indRows[i] = i;
	}
	indRows = this.randPerm(indRows);

	for (i=0; i<Math.min(cols,rows); i++){
		currMatr.message("set",indCols[i],indRows[i],1);
	}
	
}

function randPerm(ind){
	
	var currInd = ind.length;
 	var temp, randInd;

	while (0 !== currInd) {

    	randInd = Math.floor(Math.random() * currInd);
    	currInd -= 1;

    	temp = ind[currInd];
    	ind[currInd] = ind[randInd];
    	ind[randInd] = temp;
  	}

	return ind;
	
}
