var elToRead = 1; // number of elements to read before playing
var counter;
var instPlay;
var doneFact1;
var doneFact2;
var FS1requested;
var FS2requested;
var playAll;
var atLeastOne;

function init(){

	elToRead = 1;
	counter = 0;
	atLeastOne = 0;
	instPlay = 1;
	doneFact1 = 0;
	doneFact2 = 0;
	FS1requested = 0;
	FS2requested = 0;
	playAll = 0;

}


function allowClicks(){

	if (doneFact1 == 1){
		currMatr = patcher.getnamed('matr1');
		currMatr.ignoreclick = 0;
	}

	if (doneFact2 == 1){
		currMatr = patcher.getnamed('matr2');
		currMatr.ignoreclick = 0;
	}

	if ((doneFact1 + doneFact2) == 2){
		currMatr = patcher.getnamed('xMatr1');
		currMatr.ignoreclick = 0;
		currMatr = patcher.getnamed('xMatr2');
		currMatr.ignoreclick = 0;
	}

}

function setInstPlay(status){

	instPlay = status;

}

function setDoneFact1(st){
	doneFact1 = st;
}

function setDoneFact2(st){
	doneFact2 = st;
}

function doneScan(){
	var numFSrequested = FS1requested + FS2requested;

	currSubpatch = patcher.getnamed('FSaudioOut');
	currObj = currSubpatch.subpatcher().getnamed('FSrequested');
	currObj.message('set',numFSrequested);
	currObj.message('bang');

	if (FS1requested){
		this.doPlay();
	}
	if (FS2requested){
		this.doPlay2();
	}

	FS1requested = 0;
	FS2requested = 0;

}


function decodeULmat(col,row,on){

	// play all: first list is (-1,k1,k2)
	if (col<0){
		playAll = 1;
		elToRead = row*row + row*on;
		counter = 0;
		return;
	} 

	counter = counter + 1;

	if (on>0){

		if (playAll || instPlay){
		
			atLeastOne = 1;
			FS1requested = 1;

			// bang activation
			currName = 'actMs'+row;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// bang base
			currName = 'baseMs'+col;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// send activation to factorsynth~
			currObj = patcher.getnamed('collAct1');
			currObj.message('bang');

			// send base to factorsynth~
			currObj = patcher.getnamed('baseToFS1');
			currObj.message('bang');
		
		}


		if (elToRead === 1){
			if (instPlay){
				this.doneScan();
				this.doPlay();
			}
			counter = 0;
			return;
		}

	}

	if (counter === elToRead){
		if (atLeastOne>0){
			counter = 0;
			elToRead = 1;
			atLeastOne = 0;
			playAll = 0;
		}
	}


}

function decodeLRmat(col,row,on){

	// play all: first list is (-1,k1,k2)
	if (col<0){
		if (on>0){
			playAll = 1;
			elToRead = on*on + row*on;
			counter = 0;
		}
		return;
	}

	counter = counter + 1;

	if (on>0){
		
		if (playAll || instPlay){

			atLeastOne = 1;
			FS2requested = 1;

			// bang activation
			currName = 'actMs2_'+row;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// bang base
			currName = 'baseMs2_'+col;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// send activation to factorsynth~
			currObj = patcher.getnamed('collAct2');
			currObj.message('bang');

			// send base to factorsynth~
			currObj = patcher.getnamed('baseToFS2');
			currObj.message('bang');
		
		}

		if (elToRead === 1){
			if (instPlay>0){
				this.doneScan();
				this.doPlay2();
			}
			counter = 0;
		    atLeastOne = 0;
			return;
		}

	}

	if (counter === elToRead){
		if (atLeastOne>0){
			counter = 0;
			elToRead = 1;
			atLeastOne = 0;
			playAll = 0;
			return;
		}
	}


}


function decodeLLmat(col,row,on){


	counter = counter + 1;

	if (on>0){

		if (playAll || instPlay){

			atLeastOne = 1;
			FS2requested = 1;

			// bang activation
			currName = 'actMs2_'+row;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// bang base
			currName = 'baseMs'+col;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// send activation to factorsynth~
			currObj = patcher.getnamed('collAct2');
			currObj.message('bang');

			// send base to factorsynth~
			currObj = patcher.getnamed('baseToFS2');
			currObj.message('bang');
		}

		if (elToRead === 1){
			if (instPlay>0){
				this.doneScan();
				this.doPlay2();
			}
			counter = 0;
			atLeastOne = 0;
			return;
		}

	}

	if (counter === elToRead){
		if (atLeastOne>0){
			counter = 0;
			elToRead = 1;
			atLeastOne = 0;
			playAll = 0;
			return;
		}
	}


}

function decodeURmat(col,row,on){

	counter = counter + 1;

	if (on>0){
		
		if (playAll || instPlay){

			atLeastOne = 1;
			FS1requested = 1;

			// bang activation
			currName = 'actMs'+row;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// bang base
			currName = 'baseMs2_'+col;
			currObj = patcher.getnamed(currName);
			currObj.message('bang');

			// send activation to factorsynth~
			currObj = patcher.getnamed('collAct1');
			currObj.message('bang');

			// send base to factorsynth~
			currObj = patcher.getnamed('baseToFS1');
			currObj.message('bang');
		}
	
		if (elToRead === 1){
			if (instPlay>0){
				this.doneScan();
				this.doPlay();
			}
			counter = 0;
			atLeastOne = 0;
			return;
		}

	}

	if (counter === elToRead){
		if (atLeastOne>0){
			counter = 0;
			elToRead = 1;
			atLeastOne = 0;
			playAll = 0;
			return;
		}
	}


}

function doPlay(){

		currObj = patcher.getnamed('playBang1');
		currObj.message('bang');

}

function doPlay2(){

		currObj = patcher.getnamed('playBang2');
		currObj.message('bang');

}
